--=========================================================
-- 功績＿体力１桁から満タンまで回復
--=========================================================
FeatMonitor_fukutsu = {}
FeatMonitor_fukutsu.new = function ()
	
	local this = {}
	
	this.id = "fukutsu"
	this.alreadyAchieved = featInfo[this.id]
	
	this.message = ""
	this.messageCount = 0
	
	this.iconImage = love.graphics.newImage ( "featIcon_seiedama.png" )
	
	this.drawX = 0
	this.drawY = 0
	this.isMouseover = false
	
	this.name = "不屈のずんだパワー"
	this.description = "体力１桁になった後、体力満タンまでずんだ餅を取る。"
	
	
	this.phase = ""
	
	--=========================================================
	-- 最初の処理および初期化（モニタリング中のデータをクリアしたりする）
	--=========================================================
	this.init = function(self)
		
		this.phase = "notYetNearDeath"
		
		
	end
	this:init()
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function(self)
		
		if ( this.messageCount > 0) then
			this.messageCount = this.messageCount - 1
		end
		
		-- 達成済みであれば何もしない
		if ( this.alreadyAchieved ) then return end
		
		
		-- まだHP1桁になったことがない
		if ( this.phase == "notYetNearDeath" ) then
			
			if ( hp < 10 ) then
				this.phase = "alreadyNearDeathed"
			end
			
		-- 一度HP１桁になった
		elseif ( this.phase == "alreadyNearDeathed" ) then
		
			if ( hp == 100 ) then
				this.phase = "accomplished"
				
				this.message = this.name.."を達成！"
				this.messageCount = 100
				
				this.alreadyAchieved = true
				featInfo[this.id] = true
				playFeatAchievedFanfare ()
			end
		
		-- 達成済み
		elseif ( this.phase == "accomplished" ) then
			-- 処理なし
		end
		
		
		
	end
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function(self)
		
		local r, g, b, a = love.graphics.getColor()
		
		if ( this.messageCount > 0) then
		
			drawText ( this.message, 10, screenHeight - 50, {r=1,g=1,b=0})
			
		end
		
		
		love.graphics.setColor(r, g, b, a)
	end
	
	

	--=========================================================
	-- 更新：アイコンとして
	--=========================================================
	this.updateAsIcon = function(self)
		
		local width = 100
		local height = 100
		
		this.isMouseover = false
		local mouseX, mouseY = love.mouse.getPosition()
		
		if ( 
			this.drawX < mouseX and mouseX < this.drawX + width 
			and
			this.drawY < mouseY and mouseY < this.drawY + height 
		) 
		then
			this.isMouseover = true
		end
		
		
	end
	--=========================================================
	-- 描画：アイコンとして
	--=========================================================
	this.drawAsIcon = function(self, x, y)
		
		this.drawX = x
		this.drawY = y
		
		local r, g, b, a = love.graphics.getColor()
		
		
		--love.draw.rectangle("fill", x, y, 100, 100)
		--love.draw.rectangle("line", x, y, 100, 100)
		
		if ( this.isMouseover ) then
		
			love.graphics.setColor (1,1,1,0.8)
			love.graphics.rectangle ( "fill", x, y, 100, 100 )	
			
		end
		
		
		if ( this.alreadyAchieved ) then
			love.graphics.setColor (1,1,1,1)
			love.graphics.draw ( this.iconImage, x, y )
		else
			
			local currentShader = love.graphics.getShader ()
			love.graphics.setShader ( shader.grayscale )
			love.graphics.setColor (1.0,1.0,1.0,0.5)
			love.graphics.draw ( this.iconImage, x, y )
			love.graphics.setShader ( currentShader )
		end
		
		
		
		love.graphics.setColor(r, g, b, a)
	end
	

		
	return this
end

