--=========================================================
-- 功績＿エル消滅後の光を取らずに高得点達成2
--=========================================================
FeatMonitor_noParticle2 = {}
FeatMonitor_noParticle2.new = function ()
	
	local this = {}
	
	this.id = "noParticle2"
	this.alreadyAchieved = featInfo[this.id]
	
	this.message = ""
	this.messageCount = 0
	
	this.iconImage = love.graphics.newImage ( "featIcon_seizzz_b.png" )
	
	this.drawX = 0
	this.drawY = 0
	this.isMouseover = false
	
	this.goalValue = 1500
	this.name = "涅槃寂静・蓮華"
	this.description = "エル消滅後の光の粒を取らずに"..this.goalValue.."点獲得。"
	
	
	this.score_toStartCounting = 0 -- ここからカウント開始
	
	--=========================================================
	-- 最初の処理
	--=========================================================
	this.init = function(self)
		
		this.score_toStartCounting = score
		
	end
	this:init()
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function(self)
		
		if ( this.messageCount > 0) then
			this.messageCount = this.messageCount - 1
		end
		
		-- 達成済みであれば何もしない
		if ( this.alreadyAchieved ) then return end
		
		
		if ( gotParticleHappened ) then
			--print("パーティクル取った")
			this.score_toStartCounting = score
		end
		
		if ( score - this.score_toStartCounting >= this.goalValue ) then
		
			
			this.message = "["..this.name.."]を達成！"
			this.messageCount = 100
			
			featInfo[this.id] = true
			this.alreadyAchieved = true
			playFeatAchievedFanfare ()

			print( this.message )
			print( "基準：", this.score_toStartCounting )
			print( "目標：", this.score_toStartCounting + this.goalValue )

		end
		
		
	end
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function(self)
		
		local r, g, b, a = love.graphics.getColor()
		
		if ( this.messageCount > 0) then
		
			drawText ( this.message, 10, screenHeight - 50, {r=1,g=1,b=0})
			
		end
		
		
		love.graphics.setColor(r, g, b, a)
	end
	
	

	--=========================================================
	-- 更新：アイコンとして
	--=========================================================
	this.updateAsIcon = function(self)
		
		local width = 100
		local height = 100
		
		this.isMouseover = false
		local mouseX, mouseY = love.mouse.getPosition()
		
		if ( 
			this.drawX < mouseX and mouseX < this.drawX + width 
			and
			this.drawY < mouseY and mouseY < this.drawY + height 
		) 
		then
			this.isMouseover = true
		end
		
		
	end
	--=========================================================
	-- 描画：アイコンとして
	--=========================================================
	this.drawAsIcon = function(self, x, y)
		
		this.drawX = x
		this.drawY = y
		
		local r, g, b, a = love.graphics.getColor()
		
		
		--love.draw.rectangle("fill", x, y, 100, 100)
		--love.draw.rectangle("line", x, y, 100, 100)
		
		if ( this.isMouseover ) then
		
			love.graphics.setColor (1,1,1,0.8)
			love.graphics.rectangle ( "fill", x, y, 100, 100 )	
			
		end
		
		
		if ( this.alreadyAchieved ) then
			love.graphics.setColor (1,1,1,1)
			love.graphics.draw ( this.iconImage, x, y )
		else
			
			local currentShader = love.graphics.getShader ()
			love.graphics.setShader ( shader.grayscale )
			love.graphics.setColor (1.0,1.0,1.0,0.5)
			love.graphics.draw ( this.iconImage, x, y )
			love.graphics.setShader ( currentShader )
		end
		
		
		love.graphics.setColor(r, g, b, a)
	end
	

		
	return this
end

