--=========================================================
-- 功績＿テスト
--=========================================================
FeatMonitor_test = {}
FeatMonitor_test.new = function ()
	
	local this = {}
	
	this.id = "test"
	this.alreadyAchieved = featInfo[this.id]
	
	this.message = ""
	this.messageCount = 0
	
	this.iconImage = love.graphics.newImage ( "featIcon_wa-i_a.png" )
	
	this.drawX = 0
	this.drawY = 0
	this.isMouseover = false
	
	this.name = "テスト称号"
	this.description = "称号のテスト"
	
	--=========================================================
	-- 最初の処理
	--=========================================================
	this.init = function(self)
		
		
		
	end
	this:init()
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function(self)
		
		if ( this.messageCount > 0) then
			this.messageCount = this.messageCount - 1
		end
		
		-- 達成済みであれば何もしない
		if ( this.alreadyAchieved ) then return end
		
		
		if ( score > 100 ) then
			
			--this.message = this.name.."を達成！"
			--this.messageCount = 100
			
			--this.alreadyAchieved = true
		end
		
		
	end
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function(self)
		
		local r, g, b, a = love.graphics.getColor()
		
		if ( this.messageCount > 0) then
		
			drawText ( this.message, 10, screenHeight - 50, {r=1,g=1,b=0})
			
		end
		
		
		love.graphics.setColor(r, g, b, a)
	end
	
	

	--=========================================================
	-- 更新：アイコンとして
	--=========================================================
	this.updateAsIcon = function(self)
		
		local width = 100
		local height = 100
		
		this.isMouseover = false
		local mouseX, mouseY = love.mouse.getPosition()
		
		if ( 
			this.drawX < mouseX and mouseX < this.drawX + width 
			and
			this.drawY < mouseY and mouseY < this.drawY + height 
		) 
		then
			this.isMouseover = true
		end
		
		
	end
	--=========================================================
	-- 描画：アイコンとして
	--=========================================================
	this.drawAsIcon = function(self, x, y)
		
		this.drawX = x
		this.drawY = y
		
		local r, g, b, a = love.graphics.getColor()
		
		
		--love.draw.rectangle("fill", x, y, 100, 100)
		--love.draw.rectangle("line", x, y, 100, 100)
		
		if ( this.isMouseover ) then
		
			love.graphics.setColor (1,1,1,0.8)
			love.graphics.rectangle ( "fill", x, y, 100, 100 )	
			
		end
		
		
		if ( this.alreadyAchieved ) then
			love.graphics.setColor (1,1,1,1)
		else
			love.graphics.setColor (1,1,1,0.5)
		end
		
		love.graphics.draw ( this.iconImage, x, y )
		
		
		love.graphics.setColor(r, g, b, a)
	end
	

		
	return this
end

