--=========================================================
-- 三原色揃ったイベント
--=========================================================
Invocation = {}
Invocation.new = function ()
	
	local this = {}
	
	this.frameCount = -1
	
	this.lightCanvas = love.graphics.newCanvas ( WINDOW_WIDTH, WINDOW_HEIGHT )
	
	--this.cutin = love.graphics.newImage ( "1.png" )
	
	--=========================================================
	-- 初期設定
	--=========================================================
	this.init = function (self)
		
		local s = love.audio.newSource("mecha20.wav", "static")
		--local s = love.audio.newSource("power26.wav", "static")
		love.audio.play(s)
		
		
	end
	
	this:init()
	
	
	--=========================================================
	-- 最終段階で効果発動
	--=========================================================
	this.goesEffect = function(self)
		
		effectForScoreGettingNumber ( {
			value = 100, x = objects.myChar.body:getX()-100, y = objects.myChar.body:getY() - 100, font = fontBig
		})
		
		score = score + 100
		subLevel = 1
		level = level + 1

		lightBox.redNum   = lightBox.redNum - 1
		lightBox.greenNum = lightBox.greenNum - 1
		lightBox.blueNum  = lightBox.blueNum - 1
		
		for i = 1, lightBox.redNum, 1 do
			
			local entry = { 
				image = lightBox.lightRed, 
				x = lightBox.redPosX + math.random(0,10), 
				y = lightBox.redPosY + math.random(0,10), 
				frameCount = 0, 
				forceX =  math.random(0,10), 
				forceY =  math.random(0,10), 
			}
		
			lightBox.toBeScoredLightList [ #lightBox.toBeScoredLightList + 1 ] = entry
		end

		for i = 1, lightBox.greenNum, 1 do
			
			local entry = { 
				image = lightBox.lightGreen, 
				x = lightBox.redPosX + math.random(0,10), 
				y = lightBox.redPosY + math.random(0,10), 
				frameCount = 0, 
				forceX =  math.random(0,10), 
				forceY =  math.random(0,10), 
			}
		
			lightBox.toBeScoredLightList [ #lightBox.toBeScoredLightList + 1 ] = entry
		end

		for i = 1, lightBox.blueNum, 1 do
			
			local entry = { 
				image = lightBox.lightBlue, 
				x = lightBox.redPosX + math.random(0,10), 
				y = lightBox.redPosY + math.random(0,10), 
				frameCount = 0, 
				forceX =  math.random(0,10), 
				forceY =  math.random(0,10), 
			}
		
			lightBox.toBeScoredLightList [ #lightBox.toBeScoredLightList + 1 ] = entry
		end
		
		lightBox.redNum   = 0
		lightBox.greenNum = 0
		lightBox.blueNum  = 0
		
		local currentEluList = eluList
		for i = 1, #currentEluList, 1 do
			currentEluList[i]:banish()
		end
		
		-- ずんだ餅出現
		if ( #zundaList < 1 ) then
			addZunda()
		end
			
	end

	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function(self)
		
		local result = ""
		
		this.frameCount = this.frameCount + 1
		
		if ( this.frameCount == 50 ) then
			this:goesEffect()
		end
		
		if ( this.frameCount >= 50 ) then
			result = "done"
		end
		
		local colorRadius = (100-this.frameCount*3)*3
		if ( colorRadius < 0 ) then colorRadius = 0 end
		
		this.lightRedPosition = {
			x=screenWidth/2  + math.cos( math.rad( 0-90 ) ) * colorRadius, 
			y=screenHeight/2 + math.sin( math.rad( 0-90 ) ) * colorRadius, 
		}

		this.lightGreenPosition = {
			x=screenWidth/2  + math.cos( math.rad( 120-90 ) ) * colorRadius, 
			y=screenHeight/2 + math.sin( math.rad( 120-90 ) ) * colorRadius, 
		}

		this.lightBluePosition = {
			x=screenWidth/2  + math.cos( math.rad( 240-90 ) ) * colorRadius, 
			y=screenHeight/2 + math.sin( math.rad( 240-90 ) ) * colorRadius, 
		}
		
		
		this.cutinX = screenWidth - this.frameCount*50
		this.cutinY = 0

		this.textX = screenWidth - this.frameCount*20
		this.textY = screenHeight/2
		
		
		return result
	end
	
	
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function(self)

		if ( this.frameCount == -1 ) then
			return
		end
		
		local r, g, b, a = love.graphics.getColor()
			
			love.graphics.setCanvas ( this.lightCanvas )
				
				love.graphics.clear(0,0,0,0)
				
				love.graphics.setBlendMode("add")
				
				local radius = 100
			
				love.graphics.setColor(0, 0, 1, 1)
				love.graphics.circle ("fill", this.lightBluePosition.x, this.lightBluePosition.y, radius)
		
				love.graphics.setColor(0, 1, 0, 1)
				love.graphics.circle ("fill", this.lightGreenPosition.x, this.lightGreenPosition.y, radius)
				
				love.graphics.setColor(1, 0, 0, 1)
				love.graphics.circle ("fill", this.lightRedPosition.x, this.lightRedPosition.y, radius)


			love.graphics.setCanvas ()
			love.graphics.setColor(1, 1, 1, 1)
			-- https://love2d.org/wiki/BlendMode_(%E6%97%A5%E6%9C%AC%E8%AA%9E)
			love.graphics.setBlendMode("multiply","premultiplied")			
			love.graphics.draw ( this.lightCanvas, 0, 0 )
		
			love.graphics.setBlendMode("alpha")
			
			
			--love.graphics.draw ( this.cutin, this.cutinX, this.cutinY )
			
			local currentFont = love.graphics.getFont(font)
			love.graphics.setFont(fontBig)
			drawText ( "光の三原色！！", this.textX, this.textY )
			love.graphics.setFont(currentFont)
			
		
		love.graphics.setColor(r, g, b, a)
	end

	
	
		
	return this
end

