--=========================================================
-- 光
--=========================================================
Light = {}
Light.new = function ( world, x, y, colorName )
	
	local this = {}
	
	this.x = x
	this.y = y
	this.world = world
	
	this.colorName = colorName;
	
	this.object1 = nil
	
	this.frameCount = 0
	
	this.angleDegree = math.random ( 0, 360 )
	
	
	this.imageList = {}
	
	this.currentImageIndex = 1
	this.currentImageIndexFramCount = 0
	
	if ( colorName == "blue" ) then
	
		local imageQuad1 = love.graphics.newQuad(0,   0, 64, 64, lightSheet:getDimensions() )
		local imageQuad2 = love.graphics.newQuad(64,  0, 64, 64, lightSheet:getDimensions() )
		local imageQuad3 = love.graphics.newQuad(128, 0, 64, 64, lightSheet:getDimensions() )
		
		this.imageList[ #this.imageList + 1 ] = imageQuad1 
		this.imageList[ #this.imageList + 1 ] = imageQuad2 
		this.imageList[ #this.imageList + 1 ] = imageQuad3 
		this.imageList[ #this.imageList + 1 ] = imageQuad2 
		
	elseif ( colorName == "green" ) then
	
		local imageQuad1 = love.graphics.newQuad(0,   64, 64, 64, lightSheet:getDimensions() )
		local imageQuad2 = love.graphics.newQuad(64,  64, 64, 64, lightSheet:getDimensions() )
		local imageQuad3 = love.graphics.newQuad(128, 64, 64, 64, lightSheet:getDimensions() )
		
		this.imageList[ #this.imageList + 1 ] = imageQuad1 
		this.imageList[ #this.imageList + 1 ] = imageQuad2 
		this.imageList[ #this.imageList + 1 ] = imageQuad3 
		this.imageList[ #this.imageList + 1 ] = imageQuad2 
		
	elseif ( colorName == "red" ) then
	
		local imageQuad1 = love.graphics.newQuad(0,   128, 64, 64, lightSheet:getDimensions() )
		local imageQuad2 = love.graphics.newQuad(64,  128, 64, 64, lightSheet:getDimensions() )
		local imageQuad3 = love.graphics.newQuad(128, 128, 64, 64, lightSheet:getDimensions() )
		
		this.imageList[ #this.imageList + 1 ] = imageQuad1 
		this.imageList[ #this.imageList + 1 ] = imageQuad2 
		this.imageList[ #this.imageList + 1 ] = imageQuad3 
		this.imageList[ #this.imageList + 1 ] = imageQuad2 
		
	end

	--=========================================================
	-- デストラクト
	--=========================================================
	this.destruct = function (self)
		
		if ( this.object1 ~= nil ) then
			--this.object1.body:destroy()
			destroyBodyReserveList [#destroyBodyReserveList + 1]  = this.object1.body;
		end
	end
	
	--=========================================================
	-- 初期設定 
	--=========================================================
	this.putEntity = function (self)

		this.object1 = {}
		this.object1.body = love.physics.newBody ( this.world, this.x, this.y, "static")
		this.object1.body:setUserData ( {obj = this, name = "light"} )
	
		this.object1.shape   = love.physics.newCircleShape ( 20 )
	
		this.object1.fixture = love.physics.newFixture ( this.object1.body, this.object1.shape, 10) -- 3つめの値：dencity
		--this.object1.fixture:setFriction(1.0) -- 0.0 - 1.0
		--this.object1.fixture:setRestitution (0.3)
		
	end

	--=========================================================
	-- 位置セット
	--=========================================================
	this.setPosition = function(self, x, y)
		
		self.x = x
		self.y = y
		
		if ( this.object1 ~= nil ) then
			self.object1.body:setX(x)
			self.object1.body:setY(y)
		end
		
	end
	
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function(self)
		
		if ( this.object1 ~= nil ) then
			
			self.x = self.object1.body:getX()
			self.y = self.object1.body:getY()
			
			this.currentImageIndexFramCount = this.currentImageIndexFramCount + 1
			
			if ( this.currentImageIndexFramCount >= 5 ) then
				
				this.currentImageIndexFramCount = 0
				
				this.currentImageIndex = this.currentImageIndex + 1
				if ( this.currentImageIndex > #this.imageList ) then
					this.currentImageIndex = 1
				end
			end

			
		else
			
			this.frameCount = this.frameCount + 1
			
			
			
			if ( this.frameCount > -1 ) then
				this:putEntity()
			end
			
		end
		
	end
	
	
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function(self)
		
		local r, g, b, a = love.graphics.getColor()

		if ( this.object1 ~= nil ) then
		
			
			love.graphics.draw ( lightSheet, this.imageList [ this.currentImageIndex ], this.x-32, this.y-32 )
			
			-- 当たり判定
			--love.graphics.setColor( 1,1,1 )
			--love.graphics.circle ( "line", this.object1.body:getX(), this.object1.body:getY(), this.object1.shape:getRadius() )
			
		else
			
			
		end


		love.graphics.setColor(r, g, b, a)
	end
	
	
		
	return this
end

