--=========================================================
-- エルが消滅して発生するパーティクル
--=========================================================
ParticleFromElu = {}
ParticleFromElu.new = function ( world, x, y, colorData )
	
	local this = {}
	
	this.x = x
	this.y = y
	this.world = world
	
	this.colorData = colorData;
	
	this.object = nil
	
	this.frameCount = 0
	
	this.angleDegree = math.random ( 0, 360 )
	
	this.isTimeouted = false
	
	this.isTimeoutLimit = 600
	
	this.imageList = {}
	
	this.currentImageIndex = 1
	this.currentImageIndexFramCount = 0
	
	local imageQuad1 = love.graphics.newQuad( 0, 96, 32, 32, particleSheet:getDimensions() )
	local imageQuad2 = love.graphics.newQuad(32, 96, 32, 32, particleSheet:getDimensions() )
	local imageQuad3 = love.graphics.newQuad(64, 96, 32, 32, particleSheet:getDimensions() )
	
	this.imageList[ #this.imageList + 1 ] = imageQuad1 
	this.imageList[ #this.imageList + 1 ] = imageQuad2 
	this.imageList[ #this.imageList + 1 ] = imageQuad3 
	this.imageList[ #this.imageList + 1 ] = imageQuad2 
		

	--=========================================================
	-- デストラクト
	--=========================================================
	this.destruct = function (self)
		
		if ( this.object ~= nil ) then
			--this.object.body:destroy()
			destroyBodyReserveList [#destroyBodyReserveList + 1]  = this.object.body;
		end
	end
	
	--=========================================================
	-- 初期設定 
	--=========================================================
	this.putEntity = function (self)

		this.object = {}
		this.object.body = love.physics.newBody ( this.world, this.x, this.y, "dynamic")
		this.object.body:setUserData ( {obj = this, name = "particleFromElu"} )
	
		this.object.shape   = love.physics.newCircleShape ( 5 )
	
		this.object.fixture = love.physics.newFixture ( this.object.body, this.object.shape, 10) -- 3つめの値：dencity
		--this.object1.fixture:setFriction(1.0) -- 0.0 - 1.0
		--this.object1.fixture:setRestitution (0.3)
		
	end
	this:putEntity()

	--=========================================================
	-- 位置セット
	--=========================================================
	this.setPosition = function(self, x, y)
		
		self.x = x
		self.y = y
		
		if ( this.object ~= nil ) then
			self.object.body:setX(x)
			self.object.body:setY(y)
		end
		
	end
	
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function(self)
		
		this.frameCount = this.frameCount + 1
		
		if ( this.object ~= nil ) then
			
			self.x = self.object.body:getX()
			self.y = self.object.body:getY()
			
			-- アニメーション
			this.currentImageIndexFramCount = this.currentImageIndexFramCount + 1
			
			if ( this.currentImageIndexFramCount >= 2 ) then
				
				this.currentImageIndexFramCount = 0
				
				this.currentImageIndex = this.currentImageIndex + 1
				if ( this.currentImageIndex > #this.imageList ) then
					this.currentImageIndex = 1
				end
			end
			
		end
		
		if ( this.frameCount > this.isTimeoutLimit ) then
			
			this.isTimeouted = true
			
		end
		
	end
	
	
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function(self)
		
		local r, g, b, a = love.graphics.getColor()

		if ( this.object ~= nil ) then
			
			-- 消えそうなとき点滅
			local drawColor = colorData
			if ( this.frameCount > this.isTimeoutLimit - 100 and this.frameCount%2 == 0) then
				drawColor.a = 0
			else
				drawColor.a = 1.0
			end
		
			love.graphics.setColor( drawColor.r, drawColor.g, drawColor.b, drawColor.a )
			love.graphics.draw ( particleSheet, this.imageList [ this.currentImageIndex ], this.x-16, this.y-16 )
			
			-- 当たり判定
			--love.graphics.setColor( 1,0,0 )
			--love.graphics.circle ( "line", this.object.body:getX(), this.object.body:getY(), this.object.shape:getRadius() )
			
		else
			
			
		end


		love.graphics.setColor(r, g, b, a)
	end
	
	
		
	return this
end

