local utils = require "utils"

--=========================================================
-- 結果表示欄
--=========================================================
ResultWindow = {}
ResultWindow.new = function ( )
	
	local this = {}
	
	this.goalX = 80
	this.goalY = 100

	this.x = screenWidth
	this.y = this.goalY
	
	--this.forceX = 0
	--this.forceY = 0

	
	this.frameCount = 0
	
	this.charImage = love.graphics.newImage ( "taberu03_640_640.png" )
	this.charImage_love = love.graphics.newImage ( "taberu01_640_640_cameraeyed.png" )
	
	this.loveCount = 0
	
	this.loveButtonAppearScore = 1000
	this.waitToStart = 60
	
	
	this.buttonToRestart = Button.new( font, "リトライ")
	this.buttonToRestart.width  = 130
	this.buttonToRestart.height = 80
	--this.buttonToRestart.x = this.x + 10 + this.buttonToRestart.width/2
	--this.buttonToRestart.y = this.y + 250

	this.buttonToTitle = Button.new( font, "タイトル")
	this.buttonToTitle.width  = 130
	this.buttonToTitle.height = this.buttonToRestart.height
	--this.buttonToTitle.x = this.x + 10 + this.buttonToRestart.width/2  + 10 + this.buttonToRestart.width
	--this.buttonToTitle.y = this.buttonToRestart.y

	this.buttonToLove = Button.new( font, "好き")
	this.buttonToLove.width  = 130
	this.buttonToLove.height = this.buttonToRestart.height
	--this.buttonToLove.x = this.buttonToTitle.x + 10 + this.buttonToTitle.width
	--this.buttonToLove.y = this.buttonToRestart.y
		
	--=========================================================
	-- 初期設定 
	--=========================================================
	this.init = function (self)
		
		--this.charX = screenWidth - 310
		--this.charY = 120
		
		self.buttonToRestart:update()
		self.buttonToTitle:update()
		self.buttonToLove:update()
		
		--this.forceX = utils.getSign ( this.x - this.goalX )
		--this.forceY = utils.getSign ( this.y - this.goalY )
		
	end
	this:init()

	
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function(self)
		
		this.frameCount = this.frameCount + 1
		if ( this.frameCount > 9999 ) then this.frameCount = 0 end
		
		if ( this.loveCount > 0 ) then
			this.loveCount = this.loveCount - 1
		end	
		
		if ( this.frameCount == 1 ) then
			
			love.audio.stop ( bgm.play )

			local s = love.audio.newSource ( "whistle_renzoku.mp3", "static" )
			love.audio.play(s)
		end
		
		if ( this.frameCount < this.waitToStart ) then return end
		
		this.x = utils.Approach ( this.x, this.goalX, math.abs ( this.goalX - this.x  )/5 ) 
		this.y = utils.Approach ( this.y, this.goalY, math.abs ( this.goalY - this.y  )/5 ) 
--[[
		this.forceX = this.forceX + utils.getSign ( this.goalX - this.x )*10
		this.forceY = this.forceY + utils.getSign ( this.goalY - this.y )*10
		
		this.x = this.x + this.forceX
		this.y = this.y + this.forceY
		
		this.x = utils.Approach ( this.x, this.goalX, 15 ) 
		this.y = utils.Approach ( this.y, this.goalY, 15 ) 
]]--		
		
		local distanceForScore = utils.getDistance ( scorePosDefault.x, scorePosDefault.y, this.goalX + 20, this.goalY + 100)
		local distanceForLevel = utils.getDistance ( levelPosDefault.x, levelPosDefault.y, this.goalX + 20, this.goalY + 140)
		
		scorePos.x, scorePos.y = utils.Move (scorePos.x, scorePos.y, this.goalX + 20, this.goalY + 100, distanceForScore/50)
		levelPos.x, levelPos.y = utils.Move (levelPos.x, levelPos.y, this.goalX + 20, this.goalY + 140, distanceForLevel/50)

		--screenWidth - 310)  480, 320)
		this.charX = this.x + 250
		this.charY = this.y + 20

		self.buttonToRestart:update()
		self.buttonToTitle:update()
		
		

		-- 好きボタンが出る場合
		if ( score >= this.loveButtonAppearScore  ) then

			self.buttonToLove:update()

			-- ボタンの位置を随時パネルに合わせる
			this.buttonToRestart.x = this.x + 10 + this.buttonToRestart.width/2
			this.buttonToRestart.y = this.y + 250
			this.buttonToTitle.x   = this.x + 10 + this.buttonToRestart.width/2  + 10 + this.buttonToRestart.width
			this.buttonToTitle.y   = this.buttonToRestart.y
			this.buttonToLove.x    = this.buttonToTitle.x + 10 + this.buttonToTitle.width
			this.buttonToLove.y    = this.buttonToRestart.y		
		
		-- 好きボタンが出ない場合
		else
		
			-- ボタンの位置を随時パネルに合わせる
			this.buttonToRestart.x = this.x + 30 + this.buttonToRestart.width/2
			this.buttonToRestart.y = this.y + 250
			this.buttonToTitle.x   = this.x + 50 + this.buttonToRestart.width/2  + 10 + this.buttonToRestart.width
			this.buttonToTitle.y   = this.buttonToRestart.y

		end
		
		
		
		
		
		if (self.buttonToLove.isClicked) then
			this.loveCount = 60
		end
		
		if (self.buttonToRestart.isClicked) then
			sceneManager.nextScene = "play"
		end
		if (self.buttonToTitle.isClicked) then
			sceneManager.nextScene = "title"
		end
		
	end
	--this:update() -- インスタンス生成後、一回 update を通しておきたいのです。

	
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function(self)

		if ( this.frameCount < this.waitToStart ) then return end
		
		local r, g, b, a = love.graphics.getColor()
		
		
		-- 背景パネル
		if ( sceneManager.shader == nil ) then
			love.graphics.setColor ( 0.5,1.0,0.5, 0.7 )
			love.graphics.rectangle ( "fill", this.x, this.y, 480, 320)
		end
		
		-- キャラ画像		
		love.graphics.setColor ( 1.0,1.0,1.0, 1.0 )
		
		local charImage = this.charImage
		if ( this.loveCount > 0 ) then
			charImage = this.charImage_love
		end
		
		love.graphics.draw ( charImage, this.charX, this.charY, 0, 0.5,0.5 )

		drawText ( "今回の結果", this.x + 70, this.y + 10, {r=1, g=1, b=1}, fontMiddle)
		
		
		-- なんか、シェーダーがあるとボタンが真っ白になるので。
		if ( sceneManager.shader == nil ) then
			self.buttonToRestart:draw()
			self.buttonToTitle:draw()
			
			-- 好きボタン
			if ( score >= this.loveButtonAppearScore  ) then
				self.buttonToLove:draw()
			end
		end
		
		
		love.graphics.setColor(r, g, b, a)
	end
	
	
		
	return this
end

