local utils = {}
utils.getDistance = function(from_x, from_y, to_x, to_y)
	
	d = math.sqrt( (to_x - from_x)^2 + (to_y - from_y)^2 )
	
	return d
end

utils.Move = function(from_x, from_y, to_x, to_y, distance)
  	
  	result_x = from_x
  	result_y = from_y

	d = math.sqrt( (to_x - from_x)^2 + (to_y - from_y)^2 );

	--rate = ( d != 0.0f ) ? (distance / d) : 0.0f;
	rate = 0
	if ( d ~= 0 ) then 
		rate = (distance / d) 
	else 
		rate = 0 
	end

	result_x = result_x + (to_x - from_x) * rate;
	result_y = result_y + (to_y - from_y) * rate;
	

	-- Exceed
	if (from_x < to_x) then
		if ( to_x < result_x) then
			result_x  = to_x;
			result_y = to_y;
		end
	end
	if (from_x > to_x) then
		if ( to_x > result_x) then
			result_x  = to_x;
			result_y = to_y;
		end
	end
	if (from_y < to_y) then
		if ( to_y < result_y) then
			result_x = to_x;
			result_y = to_y;
		end
	end
	if (from_y > to_y) then
		if ( to_y > result_y) then
			result_x  = to_x;
			result_y = to_y;
		end
	end
	

	return result_x, result_y;
  
end





utils.Move3d = function(from_x, from_y, from_z, to_x, to_y, to_z, distance)
  	
  	result_x = from_x
  	result_y = from_y
  	result_z = from_z

	d = math.sqrt( (to_x - from_x)^2 + (to_y - from_y)^2 + (to_z - from_z)^2 );

	--rate = ( d != 0.0f ) ? (distance / d) : 0.0f;
	rate = 0
	if ( d ~= 0 ) then 
		rate = (distance / d) 
	else 
		rate = 0 
	end

	result_x = result_x + (to_x - from_x) * rate;
	result_y = result_y + (to_y - from_y) * rate;
	result_z = result_z + (to_z - from_z) * rate;
	

	-- Exceed
	if (from_x < to_x) then
		if ( to_x < result_x) then
			result_x = to_x;
			result_y = to_y;
			result_z = to_z;
		end
	end
	if (from_x > to_x) then
		if ( to_x > result_x) then
			result_x = to_x;
			result_y = to_y;
			result_z = to_z;
		end
	end
	if (from_y < to_y) then
		if ( to_y < result_y) then
			result_x = to_x;
			result_y = to_y;
			result_z = to_z;
		end
	end
	if (from_y > to_y) then
		if ( to_y > result_y) then
			result_x = to_x;
			result_y = to_y;
			result_z = to_z;
		end
	end
	if (from_z < to_z) then
		if ( to_z < result_z) then
			result_x = to_x;
			result_y = to_y;
			result_z = to_z;
		end
	end
	if (from_z > to_z) then
		if ( to_z > result_z) then
			result_x = to_x;
			result_y = to_y;
			result_z = to_z;
		end
	end

	return result_x, result_y, result_z;
  
end






utils.Approach = function( from, to, distance ) 

	result = from;

	if ( from > to ) then

		result = result - distance;

		if (result < to) then
			result = to;
		end
	
	elseif ( result < to ) then

		result = result + distance;

		if (result > to) then
			result = to;
		end
	end

	return result;
end

utils.isCollideAABB = function(pointX, pointY, boxLeftUpX, boxLeftUpY, boxWidth, boxHeight)
	
	return (
		boxLeftUpX <= pointX  and
		pointX <= boxLeftUpX + boxWidth  and
		boxLeftUpY <= pointY  and
		pointY <= boxLeftUpY + boxHeight
	)
	
end


utils.DIV = function (a, b) 
	return (a - a%b) / b
end


utils.readFile = function ( fileName ) 
	
	local result = ""
	
	local fIN, message, errorCode = io.open( fileName, "r") 
	
	if ( message or errorCode) then
		print ("【utils.readFile】message : " .. message)
		print ("【utils.readFile】errorCode : " .. errorCode)
		return ""
	end
	
	local i = 1
	for line in fIN:lines() do
		
		if ( i > 1 ) then
			result = result .. "\n"
		end
		
		result = result .. line
		
		i = i + 1
	end
	
	fIN:close()
	
	return result
end

utils.writeFile = function ( fileName, text ) 
	
	local result = ""

	fOUT, message, errorCode = io.open(fileName, "w") 

	if ( message or errorCode) then
	
		print ("【utils.writeFile】message : " .. message)
		print ("【utils.writeFile】errorCode : " .. errorCode)
	
	else
		fOUT:write( text )
	end
	
	fOUT:close()
	
	return result
	
end


-- https://helloacm.com/split-a-string-in-lua/
utils.split = function (s, delimiter)
	result = {};
	for match in (s..delimiter):gmatch("(.-)"..delimiter) do
		table.insert(result, match);
	end
	return result;
end

utils.getSign = function (a)
	result = 0;
	
	if ( a > 0 ) then result = 1 end
	if ( a < 0 ) then result = -1 end
	
	return result;
end






return utils

